 control = {}
function control.update(dt)
  -- Update controller analog positions as buttons
  if controller.count > 0 then
    --Check sticks
    local count = controller.object[save.stick]:getAxisCount()
    for i = 1, count, 2 do
      local direction = controller.object[save.stick]:getAxis(i)
      if direction < -controller.deadzone then
        if not controller.lastheld['left ' .. i] then
          love.joystickpressed(save.stick, 'left ' .. i)
          controller.lastheld['left ' .. i] = true
        end
        controller.held['left ' .. i] = true
      else
        controller.lastheld['left ' .. i] = false
        controller.held['left ' .. i] = false
      end
      if direction > controller.deadzone then
        if not controller.lastheld['right ' .. i] then
          love.joystickpressed(save.stick, 'right ' .. i)
          controller.lastheld['right ' .. i] = true
        end
        controller.held['right ' .. i] = true
      else
        controller.lastheld['right ' .. i] = false
        controller.held['right ' .. i] = false
      end
      local direction = controller.object[save.stick]:getAxis(i + 1)
      if direction < -controller.deadzone then
        if not controller.lastheld['up ' .. i] then
          love.joystickpressed(save.stick, 'up ' .. i)
          controller.lastheld['up ' .. i] = true
        end
        controller.held['up ' .. i] = true
      else
        controller.lastheld['up ' .. i] = false
        controller.held['up ' .. i] = false
      end
      if direction > controller.deadzone then
        if not controller.lastheld['down ' .. i] then
          love.joystickpressed(save.stick, 'down ' .. i)
          controller.lastheld['down ' .. i] = true
        end
        controller.held['down ' .. i] = true
      else
        controller.lastheld['down ' .. i] = false
        controller.held['down ' .. i] = false
      end
    end
    --Check hats
    for i = 1, controller.object[save.stick]:getHatCount() do
      local direction = controller.object[save.stick]:getHat(i)
      if direction == 'l' then
        if not controller.lastheld['left hat ' .. i] then
          love.joystickpressed(save.stick, 'left hat ' .. i)
          controller.lastheld['left hat ' .. i] = true
        end
        controller.held['left hat ' .. i] = true
      else
        controller.lastheld['left hat ' .. i] = false
        controller.held['left hat ' .. i] = false
      end
      if direction == 'r' then
        if not controller.lastheld['right hat ' .. i] then
          love.joystickpressed(save.stick, 'right hat ' .. i)
          controller.lastheld['right hat ' .. i] = true
        end
        controller.held['right hat ' .. i] = true
      else
        controller.lastheld['right hat ' .. i] = false
        controller.held['right hat ' .. i] = false
      end
      if direction == 'u' then
        if not controller.lastheld['up hat ' .. i] then
          love.joystickpressed(save.stick, 'up hat ' .. i)
          controller.lastheld['up hat ' .. i] = true
        end
        controller.held['up hat ' .. i] = true
      else
        controller.lastheld['up hat ' .. i] = false
        controller.held['up hat ' .. i] = false
      end
      if direction == 'd' then
        if not controller.lastheld['down hat ' .. i] then
          love.joystickpressed(save.stick, 'down hat ' .. i)
          controller.lastheld['down hat ' .. i] = true
        end
        controller.held['down hat ' .. i] = true
      else
        controller.lastheld['down hat ' .. i] = false
        controller.held['down hat ' .. i] = false
      end
    end
  end
end

function keypress.game(key)
  if key == 'escape' then
    setstate('menu', false)
    return
  end
end

-- Returns if keyboard button or matching joystick button is down
function isDown(key)
  local key2 = false
  for i = 1,#save.controller do
    if save.controller[i].name == key and love.keyboard.isDown(save.controller[i].key) then
      key2 = true
    end
  end
  if love.keyboard.isDown(key) or key2 then
    return true
  elseif controller.count > 0 then
    for i, k in pairs(save.controller) do
      if save.controller[i].key == key then
        if type(save.controller[i].button) == 'string' then
          if controller.held[save.controller[i].button] then
            return true
          end
        elseif type(save.controller[i].button) == 'number' then
          if controller.object[save.stick]:isDown(save.controller[i].button) then
            return true
          end
        end
      end
    end
  end
  return false
end

function love.keypressed(key)
  if key == 'backspace' then
    love.event.quit()
  elseif keypress[state] then
    keypress[state](key)
  end
end

-- Only used for controller configuration, calls keypress[state]
function love.joystickpressed(joystick, button)
  if type(joystick) == 'number' then
    id = joystick
  else
    id,instance = joystick:getID()
  end
  if id == save.stick then
    if buttonpress[state] then
      buttonpress[state](button)
    end
    if keypress[state] then
      for i, k in ipairs(save.controller) do
        if save.controller[i].button == button then
          keypress[state](save.controller[i].key)
        end
      end
    end
  end
end