canvas = {}
shader = {
  reload = function()
    canvas = {
      main1 = love.graphics.newCanvas(),
      main2 = love.graphics.newCanvas(),
      norm = love.graphics.newCanvas(),
    }
  end,
  effect = {
    norm = love.graphics.newShader [[
    extern Image map;
    extern number fac = .5;
    uniform sampler2D tex0;
    vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
    {
      vec4 mapcol = Texel(map, texture_coords.xy);
      vec2 uv = texture_coords.xy + (.75 - mapcol.rg)/(8/fac)*ceil(mapcol.r + mapcol.g);
      vec3 col = texture2D(tex0,uv).xyz;
      return vec4(col, 1.0);
    }
    ]],
    sand = love.graphics.newShader [[
      extern number t      = 0.0;
      uniform sampler2D tex0;
      vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
      {
        vec2 uv         = vec2(
          mod((texture_coords.x - .5)/atan(texture_coords.y/2) + mod(t/4,1),1),
          1-texture_coords.y
        );
        vec3 col        = texture2D(tex0,uv).xyz;
        return vec4( col, 1.0 );
      }
    ]],
    alpha = love.graphics.newShader [[
    extern Image map;
    uniform sampler2D tex0;
    vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
    {
      vec2 uv = texture_coords.xy;
      vec4 col = texture2D(tex0,uv).rgba;
      vec4 alph = texture2D(map,uv).rgba;
      return vec4(col.xyz, col.a-alph.r);
    }
    ]],
  },
}